"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ethBalance = exports.getProvider = void 0;
var providers_1 = require("@ethersproject/providers");
var units_1 = require("@ethersproject/units");
var detect_provider_1 = __importDefault(require("@metamask/detect-provider"));
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var T = __importStar(require("fp-ts/Task"));
var TE = __importStar(require("fp-ts/TaskEither"));
var rxjs_1 = require("rxjs");
var fp_1 = require("./fp");
exports.getProvider = function_1.pipe(fp_1.taskEitherWithError(function () { return detect_provider_1.default({ mustBeMetaMask: true }); }), TE.chain(function_1.flow(E.fromNullable(new Error('Ethereum provider not found, please install MetaMask')), TE.fromEither)), TE.map(function (provider) { return new providers_1.Web3Provider(provider); }));
var ethBalance = function (address, interval) {
    if (interval === void 0) { interval = 5000; }
    return new rxjs_1.Observable(function (subscriber) {
        var updateBalance = function (provider) {
            return subscriber.closed
                ? T.of(undefined)
                : function_1.pipe(fp_1.taskEitherWithError(function () { return provider.getBalance(address); }), TE.chain(function (balance) { return TE.fromIO(function () { return subscriber.next(units_1.formatEther(balance)); }); }), TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, function () { return function_1.pipe(updateBalance(provider), T.delay(interval)); }));
        };
        var run = function_1.pipe(exports.getProvider, TE.fold(function (e) { return T.fromIO(function () { return subscriber.error(e); }); }, updateBalance));
        run();
    });
};
exports.ethBalance = ethBalance;
//# sourceMappingURL=etherium.js.map